%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
A = [ 10 20 30; 40 50 60; 70 80 90];
R = circshift(A, 1);
REF = [ 70    80    90; 10    20    30; 40    50    60];
assert_isequal(R, REF);
%=============================================================================
A = [ 10 20 30; 40 50 60; 70 80 90];
R = circshift(A, -3);
assert_isequal(R, A);
%=============================================================================
A = [ 10 20 30; 40 50 60; 70 80 90];
R = circshift(A, -2);
REF = [    70    80    90; 10    20    30; 40    50    60];
assert_isequal(R, REF);
%=============================================================================
A = [ 10 20 30; 40 50 60; 70 80 90];
R = circshift (A, [0, 1]);
REF = [30    10    20; 60    40    50; 90    70    80];
assert_isequal(R, REF);
%=============================================================================
A = [ 10 20 30; 40 50 60; 70 80 90];
R = circshift (A, [1, 0]);
REF = [70    80    90; 10    20    30; 40    50    60];
assert_isequal(R, REF);
%=============================================================================
assert_checkerror('circshift([], NaN)', _('All values of N must be integer values.'));
%=============================================================================
