%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software: you can redistribute it and/or remify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('find'), 3);
assert_isequal(nargout('find'), 3);
%=============================================================================
R = find([1 0 2; 0 1 1; 0 0 4]);
REF = [1;5;7;8;9];
assert_isequal(R, REF);
%=============================================================================
R = find(~[1 0 2; 0 1 1; 0 0 4]);
REF = [2;3;4;6];
assert_isequal(R, REF);
%=============================================================================
X = magic(6);
X(1:2:end) = 0;
R = find(X, 4, 'last');
REF = [30; 32;34;36];
assert_isequal(R, REF);
%=============================================================================
X = magic(6);
X(1:2:end) = 0;
[R, C, V] = find(X, 4, 'last');
R_REF = [6;2;4;6];
C_REF = [5;6;6;6];
V_REF = [18;25;15;11];
assert_isequal(R, R_REF);
assert_isequal(C, C_REF);
assert_isequal(V, V_REF);
%=============================================================================
R = 1:2:20;
R = find(R == 13);
REF = 7;
assert_isequal(R, REF);
%=============================================================================
R = 0:0.1:1;
R = find(R==0.3);
REF = ones(1, 0);
assert_isequal(R, REF);
%=============================================================================
X = [18 3 1 11; 8 10 11 3; 9 14 6 1; 4 3 15 21];
[R, C] = find(X>0 & X<10, 3);
R_REF = [2; 3; 4];
C_REF = [1; 1; 1];
assert_isequal(R, R_REF);
assert_isequal(C, C_REF);
%=============================================================================
X = [3 2 0; -5 0 7; 0 0 1];
[R, C, V] = find(X);
R_REF = [1; 2; 1; 2; 3];
C_REF = [1; 1; 2; 3; 3];
V_REF = [3; -5;2; 7; 1];
assert_isequal(R, R_REF);
assert_isequal(C, C_REF);
assert_isequal(V, V_REF);
%=============================================================================
X = zeros(4,2,3);
X([1 12 19 21]) = 1;
[R, C] = find(X);
R_REF = [1; 4; 3; 1];
C_REF = [1; 3; 5; 6];
assert_isequal(R, R_REF);
assert_isequal(C, C_REF);
%=============================================================================
