%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
GIT_REPOSITORY = 'https://github.com/Nelson-numerical-software/repo_builtin_tests.git';
LOCAL_DIRECTORY = [tempdir(), 'test_repo_export', '_', createGUID()];
if isdir(LOCAL_DIRECTORY)
    rmdir(LOCAL_DIRECTORY, 's');
end
mkdir(LOCAL_DIRECTORY);
repo('export', GIT_REPOSITORY, LOCAL_DIRECTORY)
R = dir(LOCAL_DIRECTORY);
assert_isequal(length(R), 5);
REF_NAMES = {'.', '..', 'LICENSE', 'README.md', 'repo_test.nlf'};
for k = 1:length(R)
    assert_isequal(R(k).name, REF_NAMES{k});
end
%=============================================================================
if isdir(LOCAL_DIRECTORY)
    rmdir(LOCAL_DIRECTORY, 's');
end
%=============================================================================
